import greenfoot.*;

public class MyWorld extends World
{
    static DropDownMenu helpMenu; // the drrop-down menu
    static int helpIndex; // the drop-down menu setting
    static int speed = 5; // the ball speed setting
    
    // creates the drop-down menu for choosing the support class to use, if any
    static
    {
        String[] items = { "None", "QActor", "SmoothMover" };
        helpMenu = new DropDownMenu(items, 0);
    }
    
    // changing the support class
    private static void newWorld()
    {
        World world = null;
        switch (helpIndex)
        {
            case 0: world = new MyNWorld(); break;
            case 1: world = new MyQWorld(); break;
            case 2: world = new MySWorld(); break;
        }
        Greenfoot.setWorld(world);
    }
    
    // changing the ball speed
    public static void setSpeed(int s)
    {
        speed = s;
        newWorld();
    }
    
    int timer; // to control ball spawning
    int y = 26999; // the y-coordinate (when divided by 100) to spawn a ball at
    
    // creates the basics for a world
    public MyWorld()
    {
        super(800, 600, 1);
        GreenfootImage bg = getBackground();
        bg.setColor(Color.BLACK);
        bg.fill();
        showText("move("+speed+")\n\nHelper class:", 90, 275);
        setPaintOrder(DropDownMenu.class, DropDownMenu.MenuItem.class);
        addObject(helpMenu, 90, 325);
        if (helpMenu.actors[0].getWorld() != null) helpMenu.showItems();
    }
    
    // basic controls (changing speed or support class)
    public void act()
    {
        // ball spawning
        timer = (timer+1)%30;
        if (timer == 1 && (++y) < 33001) spawnBall();
        // drop-down action (changing support class)
        if (helpMenu.getSelection() != helpIndex)
        {
            helpIndex = helpMenu.getSelection();
            newWorld();
        }
        // keyboard action (setting a speed)
        String key = Greenfoot.getKey();
        if (key != null)
        {
            int s = "012345".indexOf(key);
            if (s > 0 && speed != s) setSpeed(s);
        }
    }
    
    // overridden in subclasses to spawn a ball
    public void spawnBall() {}
}