import greenfoot.*;

public class NBall extends NonHelper
{
    Color color;
    
    public NBall()
    {
        GreenfootImage img = new GreenfootImage(27, 27);
        img.setColor(Color.RED);
        img.fillOval(0, 0, 27, 27);
        setImage(img);
        setRotation(180);
    }
    
    protected void addedToWorld(World world)
    {
        color = new Color(255-(330-getY())*4, 255, (330-getY())*4);
    }
    
    public void act()
    {
        move(MyWorld.speed);
        Actor player = (Actor)getOneIntersectingObject(NOrb.class);
        if (player != null)
        {
            int dist = (player.getImage().getWidth()+getImage().getWidth())/2+1;
            if (gapTo(player) < dist)
            {
                while(gapTo(player) <= dist) move(-1);
                int dx = player.getX()-getX();
                int dy = player.getY()-getY();
                double angle = Math.atan2(dy, dx)*180/Math.PI;
                setRotation((int)(angle*2-getRotation()+180));
            }
        }
        if (isAtEdge()) getWorld().removeObject(this);
        else if (getRotation() != 180)
            getWorld().getBackground().setColorAt(getX(), getY(), color);
    }
    
    public int gapTo(Actor actor)
    {
        return (int)Math.hypot(actor.getX()-getX(), actor.getY()-getY());
    }
}