import greenfoot.*;

public class QBall extends QActor
{
    Color color;
    
    public QBall()
    {
        GreenfootImage img = new GreenfootImage(27, 27);
        img.setColor(Color.BLUE);
        img.fillOval(0, 0, 27, 27);
        setImage(img);
        setRotation(180);
        setBoundedAction(REMOVE, 0);
    }
    
    protected void addedToWorld(World world)
    {
        color = new Color(255, 255-(330-getY())*4, (330-getY())*4);
    }
    
    public void act()
    {
        move(MyWorld.speed*QVAL);
        if (getWorld() == null) return;
        QActor orb = (QActor)getOneIntersectingObject(QOrb.class);
        if (orb != null)
        {
            int dist = (orb.getImage().getWidth()+getImage().getWidth())/2+1;
            if (gapTo(orb) < dist*QVAL)
            {
                while(gapTo(orb) < dist*QVAL) move(-1);
                int dx = orb.getQX()-getQX();
                int dy = orb.getQY()-getQY();
                double angle = Math.atan2(dy, dx)*180/Math.PI;
                setQRotation((int)(angle*2*QVAL)); // +   180*QVAL-getQR() = 0   ))
            }
        }
        if (getQR() != 180*QVAL) getWorld().getBackground().setColorAt(getX(), getY(), color);
    }
    
    public double gapTo(QActor actor)
    {
        return Math.hypot(actor.getQY()-getQY(), actor.getQX()-getQX());
    }
}