import greenfoot.*;

public class SBall extends SmoothMover
{
    Color color;
    
    public SBall()
    {
        GreenfootImage img = new GreenfootImage(27, 27);
        img.setColor(Color.YELLOW);
        img.fillOval(0, 0, 27, 27);
        setImage(img);
        setRotation(180);
    }
    
    protected void addedToWorld(World world)
    {
        color = new Color(255-(330-getY())*4, (330-getY())*4, 255);
    }
    
    public void act()
    {
        move(MyWorld.speed);
        SmoothMover player = (SmoothMover)getOneIntersectingObject(SOrb.class);
        if (player != null)
        {
            int dist = (player.getImage().getWidth()+getImage().getWidth())/2;
            if (gapTo(player) < dist)
            {
                while(gapTo(player) <= dist) move(-.01);
                double dx = player.getExactX()-getExactX();
                double dy = player.getExactY()-getExactY();
                double angle = Math.atan2(dy, dx)*180/Math.PI;
                setRotation((int)(angle*2-getRotation()+180));
            }
        }
        if (isAtEdge()) getWorld().removeObject(this);
        else if (getRotation() != 180)
            getWorld().getBackground().setColorAt(getX(), getY(), color);
    }
    
    public double gapTo(SmoothMover actor)
    {
        return (int)Math.hypot(actor.getExactX()-getExactX(), actor.getExactY()-getExactY());
    }
}